library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity gen_cl is
  port(clk, reset: in std_logic;
       cl: out std_logic_vector(1 downto 0));
end gen_cl;

architecture gen_cl_arch of gen_cl is
begin
  process(clk, reset)
    variable qw: std_logic_vector(1 downto 0) := "00";
    variable byl_reset: std_logic := '0';
  begin
    if reset = '1' then
      byl_reset := '1';
      qw := "00";
    elsif falling_edge(clk) then
      if qw = "11" then
        qw := "00";
      else
        if byl_reset = '1' then
          byl_reset := '0';
        else
          qw := qw+1;
        end if; 
      end if;
    end if; 
    cl <= qw;
  end process;
end gen_cl_arch;

